/* Copyright 1998-2011 Research Foundation State University of New York */

/* This file is part of QuB.                                            */

/* QuB is free software; you can redistribute it and/or modify          */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* QuB is distributed in the hope that it will be useful,               */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License,   */
/* named LICENSE.txt, in the QuB program directory.  If not, see        */
/* <http://www.gnu.org/licenses/>.                                      */

#ifndef SPRINGDASHPOT_H
#define SPRINGDASHPOT_H

#include "LoadDataCB_Pager.h"

class SpringDashPot_Pager : public QUB_Pager {
	public:
		LoadDataCB_Pager loader;
		LoadDataCB_Pager xloader;
		double sampling;
		double damping;
		double natfreq;
		double toler;

		void *cvode_mem;
		void *y;
		double t;

		SpringDashPot_Pager( QUB_Tree segNode, QTR_NodeFptr loadDataCB, int pagesize, std::ostream& milerr, int samplesOffset, double samplingSec, double damping_ratio, double natural_freq );
		virtual ~SpringDashPot_Pager();

		void nextPage(); // call before first use

		void RHS(int n, double t, void *y, void *ydot);

};

#endif
